/*
 * pwm_generator.c
 *
 *  Created on: Oct 4, 2023
 *      Author: hussamaldean
 */


#include "pwm_generator.h"
#include "stm32f4xx.h"


void TIM1_PWM_Init(uint16_t psc, uint16_t arr, uint16_t duty)
{
	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN;

	GPIOA->MODER|=(GPIO_MODER_MODE8_1);
	GPIOA->MODER&=~(GPIO_MODER_MODE8_0);

	#define TIM1_AF 0x01
	GPIOA->AFR[1]|=(TIM1_AF <<GPIO_AFRH_AFSEL8_Pos);

	RCC->APB2ENR|=RCC_APB2ENR_TIM1EN;
	TIM1->ARR=arr;
	TIM1->PSC=psc;
	TIM1->CCMR1|=TIM_CCMR1_OC1M_2|TIM_CCMR1_OC1M_1;
	TIM1->CCER|=TIM_CCER_CC1E;
	TIM1->CCR1=duty;
	TIM1->BDTR|=0x20;
	TIM1->BDTR|=TIM_BDTR_MOE;
	TIM1->CR1|=TIM_CR1_CEN;
}

void TIM1_PWM_ChangeDuty(uint16_t duty)
{
	if (duty>100)duty=100;
	TIM1->CCR1=duty;;
}
